package com.my.config;
 
import java.lang.reflect.Method;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.method.HandlerMethod;
import org.springframework.web.servlet.HandlerInterceptor;

import com.my.model.ResponseParams;
import com.my.service.AccountService;
import com.my.utils.MyUtils;



/**
 * 解析request中的token
 * 合法才通过
 */
@Component
@CrossOrigin("*")
public class MyInterceptor implements HandlerInterceptor {
    
	@Resource
	private AccountService accountService;

    @Override
    @CrossOrigin("*")
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
    	//判断此class对象所表示的类或接口与指定的class参数所表示的类或接口是否相同
    	if(handler.getClass().isAssignableFrom(HandlerMethod.class)){ 
            HandlerMethod handlerMethod= (HandlerMethod) handler;
            Method method=handlerMethod.getMethod();
            /**
             * 是否设置不拦截，否则强制校验Authorization
             * 不存在则打回，存在则同行
             */
            AccessInterceptor methodAnnotation=method.getAnnotation(AccessInterceptor.class);
            String params = request.getParameter("params");

            if(!MyUtils.isNotNull(methodAnnotation)) {
    			String authorization = request.getHeader("Authorization");
    			if(!MyUtils.isNotNull(authorization)) {
    				response.setCharacterEncoding("UTF-8");
    		        response.setContentType("application/json;charaset=utf-8");
    		        ResponseParams resp =  ResponseParams.error("token没有传递！");
    		        String json= MyUtils.toJson(resp);
    		        response.getWriter().append(json);
    		        response.getWriter().close();
    				return false;
    			}
            }
        }
        return true;
    }

}
